//+------------------------------------------------------------------+
//|                                                                  |
//|                                                     kishartr     |
//|                                                                  |
//+------------------------------------------------------------------+
#property link      ""

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
extern double TP=20;
extern double SL=10;
extern bool traling_stop=false;
extern int TrailingStop   = 10;
extern int TrailingStep   = 3;
extern double lots = 0.2;
extern int p = 12;
extern int levup = 30;
extern int levdn = 70;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int cnt, total;
double rsi_3, rsi_2, rsi_1, rsi, rsi2;

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {//1
  int i;
  {
  for (i=0;i<OrdersTotal();i++)
   {
   if (traling_stop==true)
   if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
   TrailingPositions();
   }
  }
  
  total = OrdersTotal();
  if(total > 0)
    ClosePosition();   
  if(total < 1)
    OpenPosition();
     
   }//1
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  
void OpenPosition()
  {//1 
  
  if(Signal() > 0)
    {//2
    OrderSend(Symbol(),OP_BUY,lots,Ask,10,Ask-SL*Point,Ask+TP*Point,"Buy",0,0,Blue); 
    return(0);
    }//2
  if(Signal() < 0)
    {//2
    OrderSend(Symbol(),OP_SELL,lots,Bid,10,Bid+SL*Point,Bid-TP*Point,"Sell",0,0,Red);
    return(0);
    }//2
   
   return(0);
  }//1
  
  
 void TrailingPositions() {
  bool   ProfitTrailing = false;
  int    TrailingStop   = 10;
  int    TrailingStep   = 2;
  double pBid, pAsk, pp;

  pp = MarketInfo(OrderSymbol(), MODE_POINT);
  if (OrderType()==OP_BUY) {
    pBid = MarketInfo(OrderSymbol(), MODE_BID);
    if (!ProfitTrailing || (pBid-OrderOpenPrice())>TrailingStop*pp) {
      if (OrderStopLoss()<pBid-(TrailingStop+TrailingStep-1)*pp) {
        ModifyStopLoss(pBid-TrailingStop*pp);
        return;
      }
    }
  }
  if (OrderType()==OP_SELL) {
    pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
    if (!ProfitTrailing || OrderOpenPrice()-pAsk>TrailingStop*pp) {
      if (OrderStopLoss()>pAsk+(TrailingStop+TrailingStep-1)*pp || OrderStopLoss()==0) {
        ModifyStopLoss(pAsk+TrailingStop*pp);
        return;
      }
    }
  }
}

void ModifyStopLoss(double ldStopLoss) {
  bool fm;
  fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE);
}   
    
  
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void ClosePosition()
  {//1
  for(cnt=0;cnt<total;cnt++)
    {//2
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
    if(OrderType() <= OP_SELL && 
       OrderSymbol() == Symbol())
        {//3
         if(OrderType() == OP_BUY)
           {//4
           if(Signal() < 0)
             {//5
             OrderClose(OrderTicket(),OrderLots(),Bid,0,Red);
             return(0);
             }//5
           }//4
         if(OrderType() == OP_SELL)
           {//4
           if(Signal() > 0)
             {//5   
             OrderClose(OrderTicket(),OrderLots(),Ask,0,Blue);
             return(0);
             }//5
           }//4
         }//3
       }//2
     return(0);
   }//1
   
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int Signal()
  {//1
  rsi = iRSI(NULL,0,p,0,1);
  rsi2= iRSI(NULL,0,p,0,2);
    {//2
    if((rsi2 < levup) && (rsi > levup))
      {//3
      return(1);
      }//3
    if((rsi2 > levdn) && (rsi < levdn))
      {//3
      return(-1);
      }//3
    }//2
  return(0);
  }//1
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
/*
double UP()
  {//1
  int k;
  for(k=0;;k++)
    {//2
    rsi_3 = iRSI(NULL,0,p,0,k+3);
    rsi_2 = iRSI(NULL,0,p,0,k+2);
    rsi_1 = iRSI(NULL,0,p,0,k+1);
    if((rsi_3 < rsi_2) && (rsi_2 > rsi_1))
      {//3
      return(rsi_2);
      }//3
    }//2
  }//1
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

double DN()
  {//1
  int l;
  for(l=0;;l++)
    {//2
    rsi_3 = iRSI(NULL,0,p,0,l+3);
    rsi_2 = iRSI(NULL,0,p,0,l+2);
    rsi_1 = iRSI(NULL,0,p,0,l+1);
    if((rsi_3 > rsi_2) && (rsi_2 < rsi_1))
      {//3
      return(rsi_2);
      }//3
    }//2
  }//1
*/
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
  

